package jalview.datamodel;

/**
 * stores data for each node in the hmm model
 * @author TZVanaalten
 *
 */
public class HMMNode
{
  //contains the match emissions for each symbol 
  double[] matchEmissions;

  //contains the insert emissions for each symbol 
  double[] insertEmissions;

  // contains the state transitions for each possible transition. These are mm,
  // mi, md, im, ii, dm and dd in order
  double[] stateTransitions;
  
  //annotations
  Integer alignmentColumn = null;
  char consensusResidue;
  char referenceAnnotation;
  char maskValue;
  char consensusStructure;

  /**
   * Constructor
   */
  public HMMNode()
  {
  }

  public double[] getMatchEmissions()
  {
    return matchEmissions;
  }

  public double getMatchEmission(int symbolIndex)
  {
    return matchEmissions[symbolIndex];
  }

  public void setMatchEmissions(double[] matches)
  {
    this.matchEmissions = matches;
  }

  public double[] getInsertEmissions()
  {
    return insertEmissions;
  }

  public double getInsertEmission(int symbolIndex)
  {
    return insertEmissions[symbolIndex];
  }

  public void setInsertEmissions(double[] insertEmissionsL)
  {
    this.insertEmissions = insertEmissionsL;
  }

  public double[] getStateTransitions()
  {
    return stateTransitions;
  }

  public double getStateTransition(int transition)
  {
    return stateTransitions[transition];
  }

  public void setStateTransitions(double[] stateTransitionsM)
  {
    this.stateTransitions = stateTransitionsM;
  }

  public Integer getAlignmentColumn()
  {
    return alignmentColumn;
  }
  public void setAlignmentColumn(int alignmentColumn)
  {
    this.alignmentColumn = alignmentColumn;
  }
  public char getConsensusResidue()
  {
    return consensusResidue;
  }
  public void setConsensusResidue(char consensusResidue)
  {
    this.consensusResidue = consensusResidue;
  }
  public char getReferenceAnnotation()
  {
    return referenceAnnotation;
  }
  public void setReferenceAnnotation(char referenceAnnotation)
  {
    this.referenceAnnotation = referenceAnnotation;
  }
  public char getMaskValue()
  {
    return maskValue;
  }
  public void setMaskValue(char maskValue)
  {
    this.maskValue = maskValue;
  }
  public char getConsensusStructure()
  {
    return consensusStructure;
  }
  public void setConsensusStructure(char consensusStructure)
  {
    this.consensusStructure = consensusStructure;
  }
}
   
  
